#define INT_SISTEMA		134

/* Identificadores de las llamadas al sistema */
#define SNUEVOHILO  		1
#define STERMINARHILO	2
#define SFINHILO			3
#define SDORMIRHILO		4
#define SESCRIBIRCARACTER	5
#define SESCRIBIRCADENA		6
#define SLEERCARACTER		7

#define MK_FP( seg,ofs )( (void _seg * )( seg ) +( void near * )( ofs ))
#define FP_SEG( fp )( (unsigned )( void _seg * )( void far * )( fp ))
#define FP_OFF( fp )( (unsigned )( fp ))

typedef const void (near *pHiloFunc)(int Arg);

int MHNuevoHilo(pHiloFunc pHFuncion, int Arg);
int MHTerminarHilo(int IdHilo);
int MHFinHilo(void);
int MHDormirHilo(unsigned long NumTicks);
int MHEscribirCaracter(unsigned char c);
int MHEscribirCadena(const char far *cadena);
char MHLeerCaracter(void);
